/***************************************************************************
                          dialog.cpp  -  description
                             -------------------
    begin                : Sat Mar 3 2001
    copyright            : (C) 2001 by Jrg Khler
    email                : kisdndial@kisdndial.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dialog.h"
#include <ksimpleconfig.h>
#include <kcolorbtn.h>
#include <qcombobox.h>
#include <qcolor.h>
#include <kmessagebox.h>

dialog::dialog(QWidget *parent, const char *name ) : dialogdlg(parent,name) {
set_init();
  connect (buttonOk , SIGNAL(clicked()) , this , SLOT(setok()));
  connect (buttonOk , SIGNAL(clicked()) , this , SLOT(close()));
  connect (buttonCancel , SIGNAL(clicked()) , this , SLOT(close()));
  connect (buttonApply , SIGNAL(clicked()) , this , SLOT(setok()));
  connect (buttonDefault , SIGNAL(clicked()) , this , SLOT(reset_color()));
  connect (KColorButton3 , SIGNAL(changed()) ,this ,SLOT(setok()));
  connect (KColorButton4 , SIGNAL(changed()) ,this ,SLOT(setok()));
  connect (KColorButton5 , SIGNAL(changed()) ,this ,SLOT(setok()));
  connect (KColorButton6 , SIGNAL(changed()) ,this ,SLOT(setok()));
  connect (QRadioButton_10 , SIGNAL(clicked()), this , SLOT(check_auto()));
  connect (QradioButton13 , SIGNAL(clicked()), this , SLOT(switch_isdn_dsl()));
  connect (QradioButton13 , SIGNAL(clicked()), this , SLOT(slot_switch_dsl()));
  connect (SpinBox2 ,SIGNAL(valueChanged(int)), this , SLOT(chk_value1(int)));
  connect (SpinBox3 ,SIGNAL(valueChanged(int)), this , SLOT(chk_value2(int)));
  connect (Slider1 ,SIGNAL(valueChanged(int)),this,SLOT(set_lcd(int)));
  connect (slider2 ,SIGNAL(valueChanged(int)),this,SLOT(set_time_ID(int)));
  connect (RadioButton41,SIGNAL(clicked()),this,SLOT(chk_load()));
  connect (RadioButton11,SIGNAL(clicked()),this,SLOT(slotSwitchApplet()));
  connect (RadioButton12,SIGNAL(clicked()),this,SLOT(slotSwitchApplet()));
  connect (PushButton7 , SIGNAL(clicked()) , this , SLOT(slotSetKisdndialIcon()));

 chk_value1(0);
 chk_value2(0);
// QTime time = QTime::currentTime();

 QTimer::singleShot( (1*1000), this, SLOT(chk_dev()) );
 QTimer::singleShot( (1*1000), this, SLOT(slot_switch_dsl()) );
}
dialog::~dialog(){
}
/** initialisierung und default einstellungen laden */
void dialog::set_init(){
 KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
if (conf.readEntry("device")=="ippp0")
 QRadioButton_1->setChecked(TRUE);
if (conf.readEntry("device")=="ippp1")
 QRadioButton_2->setChecked(TRUE);
if (conf.readEntry("device")=="ippp2")
 QRadioButton_3->setChecked(TRUE);
if (conf.readEntry("device")=="ippp3")
 QRadioButton_4->setChecked(TRUE);
if (conf.readEntry("device")=="ippp4")
 QRadioButton_5->setChecked(TRUE);
if (conf.readEntry("device")=="ippp5")
 QRadioButton_6->setChecked(TRUE);
if (conf.readEntry("device")=="ippp6")
 QRadioButton_7->setChecked(TRUE);
if (conf.readEntry("device")=="ippp7")
 QRadioButton_8->setChecked(TRUE);
if (conf.readEntry("device")=="ippp8")
 QRadioButton_9->setChecked(TRUE);
 lineEdit18->setText(conf.readEntry("dslprovider"));
QLineEdit_1->setText(conf.readEntry("isdnctrl"));
QLineEdit_2->setText(conf.readEntry("ifconfig"));
QLineEdit_13->setText(conf.readEntry("tail"));
QlineEdit16->setText(conf.readEntry("pppd"));
QlineEdit17->setText(conf.readEntry("killall"));
//QLineEdit_14->setText(conf.readEntry("firewall"));
//QCheckBox_1->setChecked(conf.readBoolEntry("startfirewall"));
QCheckBox_2->setChecked(conf.readBoolEntry("display_id"));
QLineEdit_3->setText(conf.readEntry("name1"));
QLineEdit_4->setText(conf.readEntry("name2"));
QLineEdit_5->setText(conf.readEntry("name3"));
QLineEdit_6->setText(conf.readEntry("name4"));
QLineEdit_7->setText(conf.readEntry("name5"));
QLineEdit_8->setText(conf.readEntry("name6"));
QLineEdit_9->setText(conf.readEntry("name7"));
QLineEdit_10->setText(conf.readEntry("name8"));
QLineEdit_11->setText(conf.readEntry("name9"));
KColorButton3->setColor(conf.readColorEntry("color_online"));
KColorButton4->setColor(conf.readColorEntry("color_offline"));
KColorButton5->setColor(conf.readColorEntry("lcd_f"));
KColorButton6->setColor(conf.readColorEntry("lcd_r"));
KColorButton7->setColor(conf.readColorEntry("button1"));
ComboBox1->setCurrentItem(conf.readNumEntry("style",2));
ComboBox2->setCurrentItem(conf.readNumEntry("shape",0));
QcomboBox8->setCurrentItem(conf.readNumEntry("eth",0));
QRadioButton_10->setChecked(conf.readBoolEntry("auto",false));
SpinBox2->setValue(conf.readNumEntry("time2",8));
SpinBox3->setValue(conf.readNumEntry("time3",18));
ComboBox1_1->setCurrentItem(conf.readNumEntry("dev1",0));
ComboBox1_2->setCurrentItem(conf.readNumEntry("dev2",0));
ComboBox1_3->setCurrentItem(conf.readNumEntry("dev3",0));
ComboBox1_4->setCurrentItem(conf.readNumEntry("dev4",0));
ComboBox1_5->setCurrentItem(conf.readNumEntry("dev5",0));
RadioButton41->setChecked(conf.readBoolEntry("loadmeter",true));
CheckBox3->setChecked(conf.readBoolEntry("load_color_auto",true));
checkBox5->setChecked(conf.readBoolEntry("LoadOnlyEth0",false));
Slider1->setValue(conf.readNumEntry("load_height",42));
slider2->setValue(conf.readNumEntry("CallerID_time",60));
LCDNumber5->display(conf.readNumEntry("load_height",42));
QColor tmp(1,1,1);
KColorButton26->setColor(conf.readColorEntry("load_color_foreground",&tmp));
tmp.setRgb(0,255,0);
KColorButton27->setColor(conf.readColorEntry("load_color_background",&tmp));
LineEdit14->setText(conf.readEntry("exec1"));
LineEdit15->setText(conf.readEntry("exec2"));
LineEdit16->setText(conf.readEntry("exec3"));
RadioButton12->setChecked(conf.readBoolEntry("classic"));
RadioButton11->setChecked(!conf.readBoolEntry("classic"));
checkBox5_2->setChecked(conf.readBoolEntry("LeftMouse",false));
checkBox6->setChecked(conf.readBoolEntry("Time_button",false));
radioButton14->setChecked(conf.readBoolEntry("Time_button_total",true));
radioButton15->setChecked(!conf.readBoolEntry("Time_button_total",false));
switch (conf.readNumEntry("system",1))
	{
	case 1:
	QradioButton13_3->setChecked(true);
	break;
	case 2:
	QradioButton13->setChecked(true);
	break;
	case 3:
	QradioButton13_2->setChecked(true);
	break;
	}

QradioButton13_2->setEnabled(false);

check_auto();
//QradioButton13->setChecked(conf.readBoolEntry("dsl"));
switch_isdn_dsl();
set_time_ID(conf.readNumEntry("CallerID_time"));
}
/** schliesst das Fenster */
void dialog::close(){
this->hide();
}
/** bernimmt neue Einstellungen */
void dialog::setok(){
 QString tmp ;
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
if (QRadioButton_1->isChecked()) tmp="ippp0";
if (QRadioButton_2->isChecked()) tmp="ippp1";
if (QRadioButton_3->isChecked()) tmp="ippp2";
if (QRadioButton_4->isChecked()) tmp="ippp3";
if (QRadioButton_5->isChecked()) tmp="ippp4";
if (QRadioButton_6->isChecked()) tmp="ippp5";
if (QRadioButton_7->isChecked()) tmp="ippp6";
if (QRadioButton_8->isChecked()) tmp="ippp7";
if (QRadioButton_9->isChecked()) tmp="ippp8";

conf.writeEntry("device",tmp);

conf.writeEntry("dslprovider",(lineEdit18->text()));
conf.writeEntry("isdnctrl",(QLineEdit_1->text()));
conf.writeEntry("ifconfig",(QLineEdit_2->text()));
conf.writeEntry("tail",(QLineEdit_13->text()));
conf.writeEntry("pppd",(QlineEdit16->text()));
conf.writeEntry("killall",(QlineEdit17->text()));
conf.writeEntry("name1",(QLineEdit_3->text()));
conf.writeEntry("name2",(QLineEdit_4->text()));
conf.writeEntry("name3",(QLineEdit_5->text()));
conf.writeEntry("name4",(QLineEdit_6->text()));
conf.writeEntry("name5",(QLineEdit_7->text()));
conf.writeEntry("name6",(QLineEdit_8->text()));
conf.writeEntry("name7",(QLineEdit_9->text()));
conf.writeEntry("name8",(QLineEdit_10->text()));
conf.writeEntry("name9",(QLineEdit_11->text()));
conf.writeEntry("display_id",(QCheckBox_2->isChecked()));
conf.writeEntry("color_online",KColorButton3->color());
conf.writeEntry("color_offline",KColorButton4->color());
conf.writeEntry("lcd_f",KColorButton5->color());
conf.writeEntry("lcd_r",KColorButton6->color());
conf.writeEntry("button1",KColorButton7->color());
conf.writeEntry("style",ComboBox1->currentItem());
conf.writeEntry("shape",ComboBox2->currentItem());
conf.writeEntry("eth",QcomboBox8->currentItem());
conf.writeEntry("auto",QRadioButton_10->isChecked());
conf.writeEntry("dsl",QradioButton13->isChecked());
conf.writeEntry("time2",SpinBox2->value());
conf.writeEntry("time3",SpinBox3->value());
conf.writeEntry("dev1",ComboBox1_1->currentItem());
conf.writeEntry("dev2",ComboBox1_2->currentItem());
conf.writeEntry("dev3",ComboBox1_3->currentItem());
conf.writeEntry("dev4",ComboBox1_4->currentItem());
conf.writeEntry("dev5",ComboBox1_5->currentItem());
conf.writeEntry("loadmeter",RadioButton41->isChecked());
conf.writeEntry("load_color_auto",CheckBox3->isChecked());
conf.writeEntry("LoadOnlyEth0",checkBox5->isChecked());
conf.writeEntry("load_height",Slider1->value());
conf.writeEntry("load_len",Slider1->value());
conf.writeEntry("CallerID_time",slider2->value());
conf.writeEntry("load_color_foreground",KColorButton26->color());
conf.writeEntry("load_color_background",KColorButton27->color());
conf.writeEntry("exec2",(LineEdit15->text()));
conf.writeEntry("exec3",(LineEdit16->text()));
conf.writeEntry("exec1",(LineEdit14->text()));
bool temp = true;
if (RadioButton11->isChecked()) temp=false;
if (RadioButton12->isChecked()) temp=true;
conf.writeEntry("classic", temp);
conf.writeEntry("LeftMouse",checkBox5_2->isChecked());
conf.writeEntry("Time_button",checkBox6->isChecked());
conf.writeEntry("Time_button_total",radioButton14->isChecked()); // total
conf.writeEntry("Time_button_total",!(radioButton15->isChecked()));//session
if (QradioButton13_3->isChecked()) conf.writeEntry("system",1); // isdn4linux
if (QradioButton13->isChecked()) conf.writeEntry("system",2); // dsl over Ethernet
if (QradioButton13_2->isChecked()) conf.writeEntry("system",3); // smpppd
showIcon(conf.readEntry("iconname"));
 conf.sync();
emit update();

}

/** default einstellungen */
void dialog::reset_color(){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
QColor tmp(0,255,0);
KColorButton3->setColor(tmp);
tmp.setRgb(255,0,0);
KColorButton4->setColor(tmp);
tmp.setRgb(0,0,0);
KColorButton5->setColor(tmp);
tmp.setRgb(230,230,230);
KColorButton6->setColor(tmp);
KColorButton7->setColor(tmp);
ComboBox1->setCurrentItem(2);
ComboBox2->setCurrentItem(0);
ComboBox1->repaint();
ComboBox2->repaint();
KColorButton3->repaint();
KColorButton4->repaint();
KColorButton5->repaint();
KColorButton6->repaint();
}
/** wird beim click auf automatic button aufgerufen */
void dialog::check_auto(){
QRadioButton_1->setEnabled(!QRadioButton_10->isChecked());
QRadioButton_2->setEnabled(!QRadioButton_10->isChecked());
QRadioButton_3->setEnabled(!QRadioButton_10->isChecked());
QRadioButton_4->setEnabled(!QRadioButton_10->isChecked());
QRadioButton_5->setEnabled(!QRadioButton_10->isChecked());
QRadioButton_6->setEnabled(!QRadioButton_10->isChecked());
QRadioButton_7->setEnabled(!QRadioButton_10->isChecked());
QRadioButton_8->setEnabled(!QRadioButton_10->isChecked());
QRadioButton_9->setEnabled(!QRadioButton_10->isChecked());
chk_dev();
}
/** Fehlerbehandlung */
void dialog::chk_value1(int){
if ( SpinBox2->value() == 0)
ComboBox1_1->setEnabled(false);
else ComboBox1_1->setEnabled(true);
if ( SpinBox2->value() == 24)
ComboBox1_2->setEnabled(false);
else ComboBox1_2->setEnabled(true);
if (SpinBox2->value() > SpinBox3->value())
 SpinBox3->setValue(SpinBox2->value()+1);
if (SpinBox2->value() == SpinBox3->value())
 {int tmp = SpinBox3->value();
  tmp ++;
  SpinBox3->setValue(tmp);
 }
}
/** Fehlerbehandlung */
void dialog::chk_value2(int){
if ( SpinBox3->value() == 24)
ComboBox1_3->setEnabled(false);
else ComboBox1_3->setEnabled(true);
if (SpinBox3->value() == 0)
 ComboBox1_2->setEnabled(false);
else ComboBox1_2->setEnabled(true);
if (SpinBox3->value() < SpinBox2->value())
 SpinBox2->setValue(SpinBox3->value()-1);
if (SpinBox3->value() == SpinBox2->value())
 {int tmp = SpinBox2->value();
  tmp --;
  SpinBox2->setValue(tmp);
 }

}
/** berprft jede volle Stunde ob das
isdn device gendert werden muss bei automatic
Betrieb */
void dialog::chk_dev(){
QTime time = QTime::currentTime();
if (QRadioButton_10->isChecked())
 {
 QDate date = QDate::currentDate();
  if (date.dayOfWeek() <=5) chk_weekday(time);
  if (date.dayOfWeek() ==6) chk_saturday(time);
  if (date.dayOfWeek() ==7) chk_sunday(time);
 }
QTimer::singleShot( 6000, this, SLOT(chk_dev()) );
}
/** set device weekdays */
void dialog::chk_weekday(QTime time){
if ((time.hour() < SpinBox2->value()) && (ComboBox1_1->isEnabled()))
   set_device_auto(ComboBox1_1->currentItem());
if ((time.hour() >= SpinBox2->value()) && (time.hour() < SpinBox3->value()) &&
    ComboBox1_2->isEnabled())
   set_device_auto(ComboBox1_2->currentItem());
if ((time.hour() >= SpinBox3->value()) && SpinBox3->isEnabled())
   set_device_auto(ComboBox1_3->currentItem());
}
/** set device saturday */
void dialog::chk_saturday(QTime ){
 set_device_auto(ComboBox1_4->currentItem());
}
/** No descriptions */
void dialog::chk_sunday(QTime ){
 set_device_auto(ComboBox1_5->currentItem());
}
/** setzt das Device bei automatik funktion abhngig der Uhrzeit und des Wochentages
diese Funktion wird von chk_saturday(QTime) chk_sunday(QTime) und 
chk_weekday(QTime) aufgerufen */
void dialog::set_device_auto(int dev){
 switch (dev) {
       case 0: QRadioButton_1->setChecked(TRUE);
               break;
       case 1: QRadioButton_2->setChecked(TRUE);
               break;
       case 2: QRadioButton_3->setChecked(TRUE);
               break;
       case 3: QRadioButton_4->setChecked(TRUE);
               break;
       case 4: QRadioButton_5->setChecked(TRUE);
               break;
       case 5: QRadioButton_6->setChecked(TRUE);
               break;
       case 6: QRadioButton_7->setChecked(TRUE);
               break;
       case 7: QRadioButton_8->setChecked(TRUE);
               break;
       case 8: QRadioButton_9->setChecked(TRUE);
       }
setok();
}
/** No descriptions */
void dialog::set_lcd(int tmp){
LCDNumber5->display(tmp);
}

/** enabled loadmeter oder nicht... */
void dialog::chk_load(){
Slider1->setEnabled(RadioButton41->isChecked());
LCDNumber5->setEnabled(RadioButton41->isChecked());
TextLabel1->setEnabled(RadioButton41->isChecked());
TextLabel2->setEnabled(RadioButton41->isChecked());
 TextLabel3->setEnabled(RadioButton41->isChecked());
 TextLabel4->setEnabled(RadioButton41->isChecked());
 CheckBox3->setEnabled(RadioButton41->isChecked());
 KColorButton26 ->setEnabled(RadioButton41->isChecked());
 KColorButton27->setEnabled(RadioButton41->isChecked());
}
/** No descriptions */
void dialog::slotSetDev(int dev){
  QRadioButton_10->setChecked(false);
 switch (dev) {
       case 0: QRadioButton_1->setChecked(TRUE);
               break;
       case 1: QRadioButton_2->setChecked(TRUE);
               break;
       case 2: QRadioButton_3->setChecked(TRUE);
               break;
       case 3: QRadioButton_4->setChecked(TRUE);
               break;
       case 4: QRadioButton_5->setChecked(TRUE);
               break;
       case 5: QRadioButton_6->setChecked(TRUE);
               break;
       case 6: QRadioButton_7->setChecked(TRUE);
               break;
       case 7: QRadioButton_8->setChecked(TRUE);
               break;
       case 8: QRadioButton_9->setChecked(TRUE);
               break;
       case 9: QRadioButton_10->setChecked(TRUE);
               break;
	//case 10: QradioButton13->setChecked(TRUE);
    
      }
 if (dev <10) QradioButton13->setChecked(FALSE);
 check_auto();
 emit update_dsl(true);
 setok();
}
/** select Icon */
void dialog::slotSetKisdndialIcon(){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
KStandardDirs t;
QString dir = t.findResource("data","kisdndial/");
QFileDialog *file = new QFileDialog(dir,"Images(*.png )",this,"open file dialog","open this file");
file->setSelection("isdn.png");
file->show();
QString filename;
if (file->exec() == QDialog::Accepted)
 filename = file->selectedFile();
 if (!filename.isEmpty())
 {conf.writeEntry("iconname",filename);
 showIcon(filename);}
}

/** No descriptions */
void dialog::slotSwitchApplet(){
if (RadioButton12->isChecked()) emit switchApplet(true);
if (RadioButton11->isChecked()) emit switchApplet(false);
}
/** show selected Icon */
void dialog::showIcon(QString file){
QPixmap ico;
ico.load(file);
PixmapLabel1->setPixmap(ico);
//PixmapLabel1->setGeometry(0,0,48,48);
PixmapLabel1->repaint();
}

void dialog::switch_isdn_dsl()
 {
//if (!QRadioButton_10->isChecked()) {
// QRadioButton_1->setEnabled(!QradioButton13->isChecked());
// QRadioButton_2->setEnabled(!QradioButton13->isChecked());
// QRadioButton_3->setEnabled(!QradioButton13->isChecked());
// QRadioButton_4->setEnabled(!QradioButton13->isChecked());
// QRadioButton_5->setEnabled(!QradioButton13->isChecked());
// QRadioButton_6->setEnabled(!QradioButton13->isChecked());
// QRadioButton_7->setEnabled(!QradioButton13->isChecked());
// QRadioButton_8->setEnabled(!QradioButton13->isChecked());
// QRadioButton_9->setEnabled(!QradioButton13->isChecked());
//  }
// QRadioButton_10->setEnabled(!QradioButton13->isChecked());
// //chk_dev();
}
// beim bettigen der Checkbox DSL wird umgeschalten
void dialog::slot_switch_dsl()
{
//setok();
emit update_dsl(QradioButton13->isChecked());
}


// zeige per Slider eingestellte Zeit an (Ausblenden des Fenster bei Telefonanrufen)
void dialog::set_time_ID(int time_ID)
{ QString ID_time;
if (time_ID <=60)
textLabel3_2->setText(ID_time.setNum(time_ID,10)+ " sec");
else
 {
 if (time_ID < 120) textLabel3_2->setText(" 1 min "+ ID_time.setNum(time_ID-60) +" sec");
 if (time_ID < 180 && time_ID >=120 ) textLabel3_2->setText(" 2 min "+ ID_time.setNum(time_ID-120) +" sec");
 if (time_ID < 240 && time_ID >=180 ) textLabel3_2->setText(" 3 min "+ ID_time.setNum(time_ID-180) +" sec");
 if (time_ID < 300 && time_ID >=240 ) textLabel3_2->setText(" 4 min "+ ID_time.setNum(time_ID-240) +" sec");
 if (time_ID < 360 && time_ID >=300 ) textLabel3_2->setText(" 5 min "+ ID_time.setNum(time_ID-300) +" sec");
 if (time_ID < 420 && time_ID >=360 ) textLabel3_2->setText(" 6 min "+ ID_time.setNum(time_ID-360) +" sec"); 
 if (time_ID < 480 && time_ID >=420 ) textLabel3_2->setText(" 7 min "+ ID_time.setNum(time_ID-420) +" sec");
 if (time_ID < 540 && time_ID >=480 ) textLabel3_2->setText(" 8 min "+ ID_time.setNum(time_ID-480) +" sec");
 if (time_ID < 600 && time_ID >=540 ) textLabel3_2->setText(" 9 min "+ ID_time.setNum(time_ID-540) +" sec");
  if (time_ID == 600)  textLabel3_2->setText(" 10 min");
 }
}
