/***************************************************************************
                          dialog.h  -  description
                             -------------------
    begin                : Sat Mar 3 2001
    copyright            : (C) 2001 by Jrg Khler
    email                : joerg.k@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOG_H
#define DIALOG_H

#include <qwidget.h>
#include <dialogdlg.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qdatetime.h>
#include <qtimer.h>
#include <qlcdnumber.h>
#include <qslider.h>
#include <qlabel.h>
#include <qfiledialog.h>
#include <kstandarddirs.h>
/**
  *@author Jrg Khler
  */

class dialog : public dialogdlg  {
   Q_OBJECT
public: 
	dialog(QWidget *parent=0, const char *name=0);
	~dialog();
  /** No descriptions */
  void chk_sunday(QTime);
  /** set device saturday */
  void chk_saturday(QTime);
  /** set device weekdays */
  void chk_weekday(QTime);
  /** setzt das Device bei automatik funktion abhngig der Uhrzeit und des Wochentages
diese Funktion wird von chk_saturday(QTime) chk_sunday(QTime) und 
chk_weekday(QTime) aufgerufen */
  void set_device_auto(int dev);
  /** show selected Icon */
  void showIcon(QString);
private: // Private methods
  /**  */
  void set_init();
  /** No descriptions */

private slots: // Private slots
  /** accept preferences */
  void setok();
private slots: // Private slots
  /** close Windo */
  void close();
signals: // Signals
  /** No descriptions */
  void update();
public slots: // Public slots
  /** No descriptions */
  void reset_color();
  /** No descriptions */
  void check_auto();
  /** Fehlerbehandlung */
  void chk_value1(int);
  /** Fehlerbehandlung */
  void chk_value2(int);
  /** berprft jede volle Stunde ob das
isdn device gendert werden muss bei automatic
Betrieb */
  void chk_dev();
  /** No descriptions */
  void set_lcd(int);
  /** enabled loadmeter oder nicht... */
  void chk_load();
  /** No descriptions */
  void slotSetDev(int);
  /** select Icon */
  void slotSetKisdndialIcon();
  /** No descriptions */
 void slotSwitchApplet();
void switch_isdn_dsl();
	void slot_switch_dsl();
	void set_time_ID(int );


signals:
	/**
	Signal fr das ndern dsl-ISDN
	*/
	void update_dsl(bool);
  void switchApplet(bool);
};

#endif
