/***************************************************************************
                          logview.h  -  description
                             -------------------
    begin                : Mon Dec 10 2001
    copyright            : (C) 2001 by Jrg Khler
    email                : joerg.k@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LOGVIEW_H
#define LOGVIEW_H

#include <qwidget.h>
#include <logViewDlg.h>
#include <qpushbutton.h>
#include <klistview.h>
#include <kcombobox.h>
#include <qdatetime.h>
#include <ksimpleconfig.h>

/**
  *@author Jrg Khler
  */

class logView : public logViewDlg  {
   Q_OBJECT
public: 
	logView(QWidget *parent=0, const char *name=0);
	~logView();
  /** No descriptions */
  void noData();
  /** refresh the Log Window */
  void reDrawLog();
public slots: // Public slots
  /** No descriptions */
  void slotClose();
  /** No descriptions */
  void slotNewMonth(int);
  /** No descriptions */
  void slotNewDevice(int);

signals: // Signals
  /** No descriptions */
  void initMonth(int);
private: // Private attributes
  /** current month, monat is the int variable 0= January
11= December */
  int monat;
};

#endif
