/***************************************************************************
                         PPPstats.cpp  -  description
                             -------------------
    begin                : Fre Jan 3 16:16:36 GMT 2001
    copyright            : (C) 2003 by Jrg Khler
    email                : joerg.k@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>
#include <net/ppp_defs.h>

#include "PPPStats.h"
 #include <kmessagebox.h>

PPPStats::PPPStats()
       
{
    if ((_s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
        perror("couldn't create IP socket");
        exit(1);
    }

}

void PPPStats::timerEvent( )
{
struct ifreq ifreq;
  struct ppp_stats stats;
  char device_name[] = "ppp0";
  memset(&ifreq, 0, sizeof(ifreq));
  strncpy(ifreq.ifr_name, device_name, IFNAMSIZ);
  ifreq.ifr_ifru.ifru_data = (caddr_t)&stats;
  if (ioctl(_s, SIOCDEVPRIVATE, (caddr_t)&ifreq) < 0)
       emit linkStat(false);
    else
       emit linkStat(true);
      
}
