/***************************************************************************
                          infobox.cpp  -  description
                             -------------------
    begin                : Mon Mar 5 2001
    copyright            : (C) 2001 by Jrg Khler
    email                : joerg.k@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "infobox.h"
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qstring.h>
#include <qlcdnumber.h>
#include <qlabel.h>
#include <ksimpleconfig.h>

infobox::infobox(QWidget *parent, const char *name ) : info_boxdlg(parent,name) {
 log = new logView();
 connect (button1 , SIGNAL(clicked()) , this , SLOT(close()));
 connect (PushButton11 , SIGNAL(clicked()) , this , SLOT(reset_time()));
 connect (PushButton3 , SIGNAL(clicked()) , this , SLOT(slotChBundling()));
 connect (logButton , SIGNAL(clicked()) , this ,SLOT(viewLog()));
 ses1=0;ses2=0;ses3=0;channels=0;
// display_time();
}
infobox::~infobox(){
}
/** Window hide */
void infobox::close(){
this->hide();
}
/** Slot receive data (bytes,pakets,bytes,pakets,provider) */
void infobox::update(QString s1,QString s2,QString s3,QString s4,QString device,bool isConnect){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
QString s1_1,s1_2,s3_1,s3_2,s3_3;
s1_1= s1.right(3);
if (s1.length()>3)
 {s1= s1.remove(s1.length()-3,3);
  s1_2=s1.right(3);
  if (s1.length()>3)
   s1= s1.remove(s1.length()-3,3);
  else s1="";
 }
else s1="";
s3_1= s3.right(3);
if (s3.length()>3)
 {s3 = s3.remove(s3.length()-3,3);
  s3_2 = s3.right(3);
  if (s3.length()>3)
  s3 = s3.remove(s3.length()-3,3);
  else s3="";
 }
else s3="";
LCDNumber1->display(s1_1);
LCDNumber1_2->display(s1_2);
LCDNumber1_3->display(s1);
LCDNumber2->display(s2);
LCDNumber5->display(s3_1);
LCDNumber5_2->display(s3_2);
LCDNumber5_3->display(s3);
LCDNumber6->display(s4);
//QString tmp1;

QString device1;
 if (device == "ippp0"){ device1 = conf.readEntry("name1"); temp=1;}
 if (device == "ippp1"){ device1 = conf.readEntry("name2"); temp=2;}
 if (device == "ippp2"){ device1 = conf.readEntry("name3"); temp=3;}
 if (device == "ippp3"){ device1 = conf.readEntry("name4"); temp=4;}
 if (device == "ippp4"){ device1 = conf.readEntry("name5"); temp=5;}
 if (device == "ippp5"){ device1 = conf.readEntry("name6"); temp=6;}
 if (device == "ippp6"){ device1 = conf.readEntry("name7"); temp=7;}
 if (device == "ippp7"){ device1 = conf.readEntry("name8"); temp=8;}
 if (device == "ippp8"){ device1 = conf.readEntry("name9"); temp=9;}
 if (device =="ppp0"){ device1 = "DSL"; temp =10;}
tmp1 = QString::number(temp);
int time1 = conf.readNumEntry("time_sec"+tmp1,0);
int time2 = conf.readNumEntry("time_min"+tmp1,0);
int time3 = conf.readNumEntry("time_hour"+tmp1,0);
LineEdit1 ->setText(device1);
 display_time();
 if (isConnect) // time session connect
 {
  ses1++;
  time1++;

  if (ses1==60)
   {ses1=0;
    ses2++;}
   if (time1==60)
   {time1=0;
    time2++;}
   if (ses2==60)
    {ses2=0;
     ses3++;}
   if (time2==60)
    {time2=0;
     time3++;}
 conf.writeEntry("time_sec"+tmp1 , time1);
 conf.writeEntry("time_min"+tmp1 , time2);
 conf.writeEntry("time_hour"+tmp1 , time3);
 conf.sync();
 LCDNumber27->display(ses1);
 LCDNumber28->display(ses2);
 LCDNumber29->display(ses3);
 emit signalConnectTime(ses1,ses2,ses3);
 emit signalConnectTime_1(ses1,ses2,ses3,time1,time2,time3);
 }
 else
 {
 ses1 = 0;
 ses2 = 0;
 ses3 = 0;

 }
 LCDNumber86->display(time1);
 LCDNumber87->display(time2);
 LCDNumber88->display(time3);
}
/** No descriptions */
void infobox::display_time(){


}
/** No descriptions */
void infobox::reset_time(){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
ses1 =0;
ses2 =0;
ses3 =0;
 LCDNumber27->display(ses1);
 LCDNumber28->display(ses2);
 LCDNumber29->display(ses3);
 LCDNumber86->display(0);
 LCDNumber87->display(0);
 LCDNumber88->display(0);
 conf.writeEntry("time_sec"+tmp1 , 0);
 conf.writeEntry("time_min"+tmp1 , 0);
 conf.writeEntry("time_hour"+tmp1 , 0);
 conf.sync();

display_time();
}
/** Zeigt IP Nummer lokal und remote an */
void infobox::update_ip(QString inet,QString p_t_p){
 inet_txt->setText(inet);
 ptp_txt->setText(p_t_p);
}
/** zeigt aktuell gewhlte Rufnummer an */
void infobox::update_tel_number(QString tel1,QString tel2,QString ch_bundling){
tel_number->setText(tel1);
tel_number1->setText(tel2);
if ( ch_bundling == "3")
 { PushButton3->setText( "delete channel");
   channels=3;
 }
if ( ch_bundling == "1")
 { PushButton3->setText( "add channel");
 channels=1;
 }
}
/** No descriptions */
void infobox::slotChBundling(){
if (channels == 1) emit ChBundling(true);
if (channels == 3) emit ChBundling(false);
}
/** display Log Window */
void infobox::viewLog(){
this->hide();
log->show();
}

/** No descriptions */
void infobox::newDrawLog(){
log->reDrawLog();
}
