/***************************************************************************
                          isdnctrl.cpp  -  description
                             -------------------
    begin                : Tue Mar 12 2002
    copyright            : (C) 2002 by Jrg Khler
    email                : kisdndial@kisdndial.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "isdnctrl.h"

IsdnCtrl::IsdnCtrl(QWidget *parent, const char *name ) : QWidget(parent,name) {
  init();
  KSimpleConfig conf("kisdndialrc");
  conf.setGroup("default");
 if (!conf.readBoolEntry("dsl"))  
  device = conf.readEntry("device","ippp0");
  
  else device ="ppp0";
  readDev();
     timer1 = new QTimer( this );
    connect( timer1, SIGNAL(timeout()),
             this, SLOT(timer()) );

    timer1->start( 10, TRUE );
  proc_ifconfig = new  QProcess( this );
  proc_cat = new QProcess( this );
  proc_if = new QProcess( this );
  proc = new QProcess();
  programm = new QProcess();
  QString cat=Xstr(CAT);
  proc_ifconfig->addArgument( pathIfconfig );
  proc_cat->addArgument(cat) ;
  proc_cat->addArgument("/dev/isdninfo");
  proc_if->addArgument("/bin/ls");
  proc_if->addArgument("-l");
  proc_if->addArgument(pathIsdnctrl);

  connect(proc_ifconfig,SIGNAL(readyReadStdout()),this,SLOT(IPadress()));
  connect(proc_cat,SIGNAL(readyReadStdout()),this,SLOT(readISDNinfo()));
  connect(proc_if,SIGNAL(readyReadStdout()),this,SLOT(access_test_isdnctrl()));

  if (!proc_ifconfig->start())
  {static MyMsgBox * wbox4;
    wbox4 = new MyMsgBox("4","Warning Error not run: " +pathIfconfig ,"set Path in Preferences and or check access permission (root: chmod 755 "+ pathIfconfig+" )" ,0,0,0);
    wbox4->show();}

  access_test_isdninfo();
  chbundl=false;
  if (!conf.readBoolEntry("dsl"))  slot_start_process(false);

}
IsdnCtrl::~IsdnCtrl(){
proc_cat->kill();
//proc_cat1.kill();
writeEndLog();
}
/** read proc/net/dev , reply s1, s2 , s3 ,s4 */
void IsdnCtrl::readDev(){
QString s , s_tmp;
bool devFound = false;
    QFile f("/proc/net/dev");       // statistik berechnen
if ( f.open(IO_ReadOnly) ) {    // file opened successfully
QTextStream t( &f );        // use a text stream

while ( !t.eof() ) {        // until end of file...
s = t.readLine();
if (s.find(device) > 0)
 { s_tmp = s; 
  if ((device=="ppp0") && (s.find("ippp") > 0)) devFound = false;
  else
  {devFound = true;
  break;}
 }
 else devFound = false;
}
f.close();
}
if (devFound)
{
s_tmp.remove(1,6);
s = s_tmp.simplifyWhiteSpace();  // delete space
s1=s.left(s.find(" "));    // s1 receive Byte
s.remove(0,(1+s.find(" ")));
s2=s.left(s.find(" "));     //s2 receive Paket`s
s.remove(0,(1+s.find(" ")));
for(int count=0 ;count < 6;count++)
 {s.remove(0,(1+s.find(" ")));
 }
s3=s.left(s.find(" "));   //s3 transmitt Byte
s.remove(0,(1+s.find(" ")));
s4=s.left(s.find(" "));    //s4 transmitt Paket`s
}
}
/** 1s timer  */
void IsdnCtrl::timer(){
  KSimpleConfig conf("kisdndialrc");
  conf.setGroup("default");
if(!conf.readBoolEntry("dsl"))
{if (!isConnect)  device = conf.readEntry("device");}
else 
{if (conf.readBoolEntry("LoadOnlyEth0"))
 {
    switch (conf.readNumEntry("eth"))
               {
	       case 0:
	       device = "eth0";
	       break;
	       case 1:
	       device = "eth1";
	       break;
	       case 2:
	       device ="eth2";
	       break;
	       case 3:
	       device ="eth3";
	       break;
	       device ="eth0";
	       }
 
//device = "eth0";  // Loadmeter eth0 oder ppp0 !!!
 }
 else device ="ppp0";
}  
  conf.sync();
readDev();
double tmp;
tmp = s1.toDouble();
double tmp_1 = tmp - i_bytes;  // Qstring to double
i_bytes = tmp;
tmp = s3.toDouble();
double tmp_2 =  tmp - o_bytes;
o_bytes = tmp;
tmp_1 = tmp_1  / 1024;  // in
tmp_2 = tmp_2 / 1024;   // out
emit update_load(tmp_1,tmp_2); //bertragungsrate pro sek.
emit update_signal(s1,s2,s3,s4,device,isConnect);//send data to infobox
  QDateTime now = QDateTime::currentDateTime();//sync to time
  int msecs = 1000 - now.time().msec();
  if (msecs < 100)
   {msecs+=1000;
   }
   emit timer2();
   timer1->start( msecs, TRUE ); //start new timer
}

/** start stop connections */
void IsdnCtrl::run_isdnctrl(){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
conf.sync();

QString args;
//pathIsdnctrl = conf.readEntry("isdnctrl");

  if (!isConnect)
  {

    args = conf.readEntry("exec1");

  if ( args.length() > 0)
  { QString args1="", args2="", args3="", args4="", args5="" , args6="";
   // find programm arguments
   if (args.find(" ")>=0)
    {args1=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
    else
     {if (!args.isEmpty())
      args1 = args;
      args.remove(0,args.length());
     }
    if (args.find(" ")>=0)
    {args2=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args2 = args;
       args.remove(0,args.length());
      }
    if (args.find(" ")>=0)
    {args3=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args3 = args;
       args.remove(0,args.length());
      }
      if (args.find(" ")>=0)
    {args4=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args4 = args;
       args.remove(0,args.length());
      }
     if (args.find(" ")>=0)
    {args5=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args5 = args;
       args.remove(0,args.length());
      }
    if (args.find(" ")>=0)
    {args6=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args6 = args;
       args.remove(0,args.length());
      }
      	programm->clearArguments();
	programm->addArgument(args1);
	programm->addArgument(args2);
	programm->addArgument(args3);
	programm->addArgument(args4);
	programm->addArgument(args5);
	programm->addArgument(args6);
	programm->start();

   }
   // Abfrage ISDN oder DSL bei Anwahl
   if (!conf.readBoolEntry("dsl"))
   {proc->clearArguments ();
   proc->addArgument(conf.readEntry("isdnctrl"));
   proc->addArgument("dial");
   proc->addArgument(device);
   }
   //proc << (conf.readEntry("isdnctrl")) <<"dial" <<device;
   else
   { QString eth;
    switch (conf.readNumEntry("eth"))
               {
	       case 0:
	       eth = "eth0";
	       break;
	       case 1:
	       eth = "eth1";
	       break;
	       case 2:
	       eth ="eth2";
	       break;
	       case 3:
	       eth ="eth3";
	       break;
	       eth ="eth0";
	       }
   if (conf.readEntry("dslprovider")== "")
   { proc->clearArguments();
     proc->addArgument(conf.readEntry("pppd"));
     proc->addArgument(eth);
   }
   //proc  << (conf.readEntry("pppd"))  << eth;
   else
   {proc->clearArguments();
    proc->addArgument(conf.readEntry("pppd"));
    proc->addArgument("call");
    proc->addArgument(conf.readEntry("dslprovider"));
    proc->addArgument(eth);
    }

  } //end else

  if (!chbundl)
  { proc->start();
  }
  }
 if (isConnect)
  {
    programm->clearArguments();
    args = conf.readEntry("exec3");
  if ( args.length() > 0)
  { QString args1="", args2="", args3="", args4="", args5="" , args6="";
   // find programm arguments
    if (args.find(" ")>=0)
    {args1=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
    else
     {if (!args.isEmpty())
      args1 = args;
      args.remove(0,args.length());
     }
    if (args.find(" ")>=0)
    {args2=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args2 = args;
       args.remove(0,args.length());
      }
    if (args.find(" ")>=0)
    {args3=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args3 = args;
       args.remove(0,args.length());
      }
      if (args.find(" ")>=0)
    {args4=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args4 = args;
       args.remove(0,args.length());
      }
     if (args.find(" ")>=0)
    {args5=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args5 = args;
       args.remove(0,args.length());
      }
    if (args.find(" ")>=0)
    {args6=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args6 = args;
       args.remove(0,args.length());
      }
      programm->clearArguments();
     programm->addArgument(args1);
      programm->addArgument(args2);
      programm->addArgument(args3);
      programm->addArgument(args4);
      programm->addArgument(args5);
     programm->addArgument(args6);
     programm->start();
   }
   //Abfrage ISDN DSL beim trennen der Verbindung
    if (!conf.readBoolEntry("dsl"))
	{
	proc->clearArguments();
	proc->addArgument(conf.readEntry("isdnctrl"));
	proc->addArgument("hangup");
	proc->addArgument(device);
	//proc <<(conf.readEntry("isdnctrl")) <<"hangup" <<device;
	proc->start();

	}
   else
	{
	proc->clearArguments();
	proc->addArgument(conf.readEntry("killall"));
	proc->addArgument("pppd");
	//proc << (conf.readEntry("killall")) << "pppd";
	proc->start();
	programm->clearArguments();
	programm->addArgument("bin/echo");
	programm->addArgument("0");
	programm->addArgument("> /var/log/ppp");
	//programm << "/bin/echo" << "0" << "> /var/log/ppp";
	programm->start();
	}
	writeEndLog();
  }
}
/** Initiatisierung Name of isdn device */
void IsdnCtrl::init(){
  KSimpleConfig conf("kisdndialrc");
  conf.setGroup("default");
for (int count=1 ;count<10;count++)         //init 1
{                                          // init1
QString tmp1;                              //init1
tmp1 = QString::number(count);             //init1
int time = conf.readNumEntry("time_sec"+tmp1,0); //init1
conf.writeEntry("time_sec"+tmp1 , time);        //lege 10 Zeitzhler !
time = conf.readNumEntry("time_min"+tmp1,0);    //an dev ippp0 -ippp9
conf.writeEntry("time_min"+tmp1 , time);        //min sec und hour
time = conf.readNumEntry("time_hour"+tmp1,0);   //             
conf.writeEntry("time_hour"+tmp1 , time);      //init 1           
}
QString name;
bool isDisplayID = conf.readBoolEntry("display_id",TRUE);      // zeige
conf.writeEntry("display_id",isDisplayID);                //anrufer
pathIsdnctrl = conf.readEntry("isdnctrl",Xstr (ISDNCTRL)); //Path config.h
conf.writeEntry("isdnctrl",pathIsdnctrl);                   //pfade
pathIfconfig = conf.readEntry("ifconfig", Xstr (IFCONFIG));  //pfade
conf.writeEntry("ifconfig",pathIfconfig);                 //pfade
pathTail = conf.readEntry("tail", Xstr (TAIL));           //pfade
conf.writeEntry("tail",pathTail);                    //pfade
name = conf.readEntry("name1","name");             //namen ippp0
conf.writeEntry("name1",name);
name = conf.readEntry("name2","name");
conf.writeEntry("name2",name);
name = conf.readEntry("name3","name");
conf.writeEntry("name3",name);
name = conf.readEntry("name4","name");
conf.writeEntry("name4",name);
name = conf.readEntry("name5","name");
conf.writeEntry("name5",name);
name = conf.readEntry("name6","name");
conf.writeEntry("name6",name);
name = conf.readEntry("name7","name");
conf.writeEntry("name7",name);
name = conf.readEntry("name8","name");
conf.writeEntry("name8",name);
name = conf.readEntry("name9","name");          //bis ippp8
conf.writeEntry("name9",name);
}

/** Slot 
wird aufgerufen wenn neue Daten aus 
/dev/isdninfo gelesen werden
z.b. bei der Einwahl und Abwahl */
void IsdnCtrl::readISDNinfo(){

KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
QString input ,input_tmp ,tel1 , tel2 , ch_bundling ,args;
input ="";
while (proc_cat->canReadLineStdout()) input += proc_cat->readLineStdout();
if (!conf.readBoolEntry("dsl"))
{ //isdn aktiv
 input_tmp= input.mid(7+input.find("usage"),1);
 if (input_tmp!="0")
 {// Anwahl noch kein connect
 QColor colConnect(yellow);
 emit setConnect(colConnect,false);
 input_tmp= input.mid(7+input.find("flags"),1);
 ch_bundling = input_tmp;
   if  ((input_tmp!="0") && !isConnect)
   {// connect
   // execute user programm upon connect and write Log
   writeLog();

  emit setConnect(conf.readColorEntry("color_offline"),true);
  isConnect = true;
  // programm->start();
   QTimer::singleShot(5000, this, SLOT(start_ifconfig()));//read IP Adress
  }
 }
 else  //abwahl
 {
  emit setConnect(conf.readColorEntry("color_online"),false);
  if (isConnect) writeEndLog();
  isConnect = false;
  chbundl=false;
  QTimer::singleShot(5000, this, SLOT(start_ifconfig())); //read IP Adress

}
// read telephone number and channel bundling and emitt signal
input_tmp= input.mid(7+input.find("phone"),35);
if (input_tmp =="") return;
tel1 = input_tmp.left(input_tmp.find(" "));
if (tel1 == "???") tel1 = "not connected";
input_tmp = input_tmp.remove(0,(1+input_tmp.find(" ")));
tel2 = input_tmp.left(input_tmp.find(" "));
if (tel2 == "???") tel2 = "not connected";
emit update_tel_number(tel1,tel2,ch_bundling);
}
}
/** aktiviert Kanalbndelung */
void IsdnCtrl::slotChBundling(bool enabled){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
conf.sync();
pathIsdnctrl = conf.readEntry("isdnctrl");
 proc->clearArguments();
  if (enabled)
  {
  proc->addArgument(pathIsdnctrl);
  proc->addArgument("addlink");
  proc->addArgument(device);
  }
  //proc << pathIsdnctrl <<"addlink" <<device;

  else
 {
  proc->addArgument(pathIsdnctrl);
  proc->addArgument("removelink");
  proc->addArgument(device);
 }
  //proc << pathIsdnctrl <<"removelink" << device;
  chbundl=true;
  proc->start();

}
/** read IP Adress and transmitt to infobox */
void IsdnCtrl::IPadress(){
QString ifconfig , tmp_ifconfig , inet , p_t_p;

while (proc_ifconfig->canReadLineStdout())
 ifconfig += proc_ifconfig->readLineStdout() ;
if (ifconfig.find(device) > 0)
 {
  tmp_ifconfig = ifconfig.remove(0,(20+ifconfig.find(device)));

  if (tmp_ifconfig.find("addr") >=0)
  ifconfig = tmp_ifconfig.remove(0,(5+tmp_ifconfig.find("addr")));
  if (tmp_ifconfig.find("dresse") >=0)
  ifconfig = tmp_ifconfig.remove(0,(7+tmp_ifconfig.find("dresse")));
  inet = ifconfig.left(ifconfig.find(" "));
  if (tmp_ifconfig.find("P-t-P") >=0)
  ifconfig = tmp_ifconfig.remove(0,(6+tmp_ifconfig.find("P-t-P")));
  if (tmp_ifconfig.find("P-z-P") >=0)
  ifconfig = tmp_ifconfig.remove(0,(6+tmp_ifconfig.find("P-z-P")));
  p_t_p = ifconfig.left(ifconfig.find(" "));
   emit update_ip_adress(inet,p_t_p);
  }
}
/** No descriptions */
void IsdnCtrl::start_ifconfig(){
 if (!proc_ifconfig->start())
  {;}
}
/** permission test */
void IsdnCtrl::access_test_isdninfo(){
  KSimpleConfig conf("kisdndialrc");
  conf.setGroup("default");
   QFile isdninfo("/dev/isdninfo");
  if (!isdninfo.open(IO_ReadOnly)) //File open
   { if (!conf.readBoolEntry("warning1"))
    {static MyMsgBox * wbox1;
    wbox1 = new MyMsgBox("1","Warning","cannot read /dev/isdninfo (chmod 644 /dev/isdninfo)",0,0,0);
    wbox1->show();}
   }
 }

/** permission test */
void IsdnCtrl::access_test_isdnctrl(){
  KSimpleConfig conf("kisdndialrc");
  conf.setGroup("default");
 QString access , tmp;
 while (proc_if->canReadLineStdout()) access += proc_if->readLineStdout();
 access.remove(0,3);
 access.remove(7,6);
 tmp = access;
 access.remove(1,7);
 if  (!(access == "s"))
  {if (!conf.readBoolEntry("warning2"))
    {static MyMsgBox * wbox2;
    wbox2 = new MyMsgBox("2","Warning","! set SUID Bit \n\n(root: chmod 4755 isdnctrl)",0,0,0);
    wbox2->show();}
  }
  access = tmp;
 access.remove(0,3);
 access.remove(1,2);
  if ( access =="--")
  {if (!conf.readBoolEntry("warning3"))
    {static MyMsgBox * wbox3;
    wbox3 = new MyMsgBox("3","Warning ! check access permission execute by group and others:","(root: chmod 4755 isdnctrl)  execute by group: (root: chmod 4754 isdnctrl)",0,0,0);
    wbox3->show();}
  }
 }
/** No descriptions */
void IsdnCtrl::writeEndLog(){
QString temp1;
KSimpleConfig log("kisdndiallog");
QDate Datum = QDate::currentDate();
QTime Time = QTime::currentTime();
int monat = Datum.month();
log.setGroup(temp1.setNum(monat,10));
int num = log.readNumEntry("lognum");
QString num1;
if ((!log.hasKey(num1.setNum(num,10)+"end"))&&(log.hasKey(num1.setNum(num,10)+"begin")))
log.writeEntry(num1.setNum(num,10)+"end",Time.toString()+";"+s1 +";"+s3+";"+num1.setNum(time1,10)+
               ";"+num1.setNum(time2,10)+";"+num1.setNum(time3,10));
emit update_log(); // refresh Log
}
/** set Connect Time */
void IsdnCtrl::slotSetConnectTime(int t1,int t2,int t3){
time1=t1;
time2=t2;
time3=t3;
}


void IsdnCtrl::writeLog()
{
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
KSimpleConfig log("kisdndiallog");
 QString num1,temp1,args;
QDate Datum = QDate::currentDate();
QTime Time = QTime::currentTime();
int monat = Datum.month();
log.setGroup(temp1.setNum(monat,10));
QString args1="", args2="", args3="", args4="", args5="" , args6="";
   programm->clearArguments();
   args = conf.readEntry("exec2");
   // find programm arguments
   if (args.find(" ")>=0)
   {args1=args.left(args.find(" "));
    args.remove(0,(1+args.find(" ")));
   }
   else
     {if (!args.isEmpty())
      args1 = args;
      args.remove(0,args.length());
     }
    if (args.find(" ")>=0)
    {args2=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args2 = args;
       args.remove(0,args.length());
      }
    if (args.find(" ")>=0)
    {args3=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args3 = args;
       args.remove(0,args.length());
      }
      if (args.find(" ")>=0)
    {args4=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args4 = args;
       args.remove(0,args.length());
      }
     if (args.find(" ")>=0)
    {args5=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args5 = args;
       args.remove(0,args.length());
      }
    if (args.find(" ")>=0)
    {args6=args.left(args.find(" "));
     args.remove(0,(1+args.find(" ")));
    }
     else
      {if (!args.isEmpty())
       args6 = args;
       args.remove(0,args.length());
      }

      programm->addArgument(args1);
      programm->addArgument(args2);
      programm->addArgument(args3);
      programm->addArgument(args4);
      programm->addArgument(args5);
      programm->addArgument(args6);
   //programm <<args1 <<args2 <<args3 <<args4 <<args5 <<args6;
 if ((!isConnect) && (!chbundl))
  programm->start();
//LOG
 if (!(log.readNumEntry("year",2002) == Datum.year()))  // old Log?
  { if (log.deleteGroup(temp1.setNum(monat,10),true))
    log.setGroup(temp1.setNum(monat,10)); }

log.writeEntry("lognum",(log.readNumEntry("lognum",0) +1));
int num = log.readNumEntry("lognum");

log.writeEntry(num1.setNum(num,10)+"begin",temp1.setNum(Datum.day(),10)+";"+Time.toString()+";" + device+";"+s1+";" +s3);
 log.writeEntry("year",Datum.year());

}

/**
startet berwachung dsl oder isdn
*/
void IsdnCtrl::slot_start_process(bool dsl_isdn)
{

if (dsl_isdn)
{device ="ppp0";
proc_cat->kill();
}
else
{
KSimpleConfig conf("kisdndialrc");
  conf.setGroup("default");
  device = conf.readEntry("device","ippp0"); 
 proc_cat->start();
}
}

void IsdnCtrl::readPPPinfo(bool linkup)
{
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");

if (!linkup && isConnect && conf.readBoolEntry("dsl"))  //Verbindung wird abgebaut
{  emit setConnect(conf.readColorEntry("color_online"),false);
   isConnect = false;
   writeEndLog();
   QTimer::singleShot(5000, this, SLOT(start_ifconfig()));//read IP Adress
 }

if (linkup && !isConnect && conf.readBoolEntry("dsl"))  // Verbindung wird aufgebaut
{ writeLog();
 emit setConnect(conf.readColorEntry("color_offline"),true);
 isConnect = true;
 programm->start();
 QTimer::singleShot(5000, this, SLOT(start_ifconfig()));//read IP Adress
 }
}
