/***************************************************************************
                          kisdndial.h  -  description
                             -------------------
    begin                : Fre Mr  2 16:16:36 GMT 2001
    copyright            : (C) 2001 by Jrg Khler
    email                : joerg.k@web.de
    
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KISDNDIAL_H
#define KISDNDIAL_H

#ifdef HAVE_CONFIG_H
#define Str(x)	#x
#define Xstr(x)	Str(x)
#include <config.h>
#endif
#include <kpanelapplet.h>
#include <ksimpleconfig.h>
#include <qstring.h>
#include <qlayout.h>
#include <qpainter.h>
#include "dialog.h"
#include "infobox.h"
#include "phone.h"
#include "isdnctrl.h"
#include "PPPStats.h"
#include <kglobal.h>
#include <klocale.h>
#include <kapplication.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <kaboutdialog.h>
#include <kaboutapplication.h>
#include <kaboutdata.h>
#include <kpopupmenu.h>
#include <qpixmap.h>
#include <qlabel.h>
#include "mymsgbox.h"




class Kisdndial : public KPanelApplet
{
Q_OBJECT
public:
/**
* Construct a @ref KPanelApplet just like any other widget.
*
* @param configFile The configFile handed over in the factory function.
* @param Type The applet @ref type().
* @param actions Standard RMB menu actions supported by the applet (see @ref action() ).
* @param parent The pointer to the parent widget handed over in the factory function.
* @param name A Qt object name for your applet.
**/
Kisdndial(const QString& configFile, Type t = Stretch, int actions = 0,
        QWidget *parent = 0, const char *name = 0);
/** destructor */
~Kisdndial();

enum SYSTEM { NO,ISDN4LINUX , DSL , SMPPP};
SYSTEM sys_tem;

int widthForHeight( int height ) const;
/**

**/
int heightForWidth( int width) const;
/**

**/
void about();
void help();
void preferences();
  /** No descriptions */
  void paintEvent(QPaintEvent *);
  /** No descriptions */
  void loadIcons();
  /** Paint "loadmeter */
QPushButton* button_1;
QPushButton* button_2;
QLCDNumber* lcd_1;
  /** shows Icon */
  QLabel *iconApplet;

  /**  */
private:
   double load_tmp[100];
    /**  */
  QColor color_online;
  /**  */
  QColor color_offline,lcd_f ,lcd_r ,button1_color;
  /**  */
  infobox *ibox;
  /** Bearbeitet ankommende Telefonanrufe */
  phone * phoneNumber;
  dialog *dlg;
  PPPStats *p_status;
//  ServerConnection * p_smpppctl;
  KAboutWidget *kisdndialabout;
   KAboutData *data;
  KPopupMenu *menu;
  KPopupMenu *dev;
  KPopupMenu *dev_smppp;
  KPopupMenu *dev_smppp_if;
  KPopupMenu *dev_smppp_pr;
  QPixmap ico1;
  QPixmap ico2;
  QPixmap ico3;
  QPixmap ico4;
  QPixmap ico5;
  /**  */
    /**  */
  IsdnCtrl *isdn;
private: // Private methods

  /**  */
  bool isConnect;
  /** Applett old or new ( Icon) */
  bool appNewOld;
  /** Construct old Applet */
  void initApplettOld();
  /** set new color */
  void newStatus();
  /** No descriptions */
  void draw_loadmeter(double);
  /** No descriptions */
  void paint_loadmeter();
  /** set default for first run */
  void firstRun();
  /** No descriptions */
  void newsize();

public slots: // Public slots
  /** show Infos */
  void info_box();
  /** new color lcd button1 and button2
LCD style */
  void new_color();
  /** set Connect and new Colors */
  void slotSetConnect(QColor,bool);
  /** No descriptions */
  void setLoad(double,double);
  /** menu->about */
  void menuAbout();
  void menuHelp();
  void menuPreference();
  void exit();
  /** No descriptions */
  void slotSwitchApplet(bool);
	void slotShowTime(int,int,int,int,int,int);
protected: // Protected methods
  /** No descriptions */
  void resizeEvent(QResizeEvent*);
  void mousePressEvent(QMouseEvent*);


private: bool set_interface;
		bool ask_password;
};

#endif
